/*
  ARPACK++ v1.0 8/1/1997
  c++ interface to ARPACK code.

  MODULE arcomp.h
  arcomplex complex type definition.

  ARPACK Authors
     Richard Lehoucq
     Danny Sorensen
     Chao Yang
     Dept. of Computational & Applied Mathematics
     Rice University
     Houston, Texas
*/

#ifndef ARCOMP_H
#define ARCOMP_H

#include <complex>

/*
  Always define arcomplex to be complex
  complex<> should be fairly well supported
  by all compilers by now
  
  The #else part of the #if 1 is the former version of 
  this file
 */
#if 1

# define arcomplex std::complex

#else

#ifdef __GNUG__
  
#define arcomplex complex

#endif

#if defined(__SUNPRO_CC) || defined(__sgi)

  template <class FLOAT>
  class arcomplex: public complex
  {
   public:

    arcomplex(FLOAT x, FLOAT y): complex(x,y) { }
    arcomplex(): complex() { }
    arcomplex(complex x): complex(x) { }

  };

#endif
#endif

#endif // ARCOMP_H



